/*

Ein einfacher Wrapper um das jQuery Ajax. Ruft asynchron einen URL auf unter dem JSON 
liegt, reichert das resultierende JSON Objekt um Kontextinformationen an und uebergibt das
Ganze an einen Callback.
 
Methode:

	- getAsync(url, onRes, timeout)

Argumente:

	- url	
		der url
	- onRes
		derCallback	
	-timeout
		(optionaler) Timeout default = kein timeout
		
Rueckgabewerte (gekapselt im Rueckgabeobjekt):
	- url
		der URL
	- jqXHR
		das JQuery Kontext Objekt
	- textStatus
		der ResponseCode			
	- data
		das JSON Daten Objekt - fehlt bei Fehler
	- errorThrown
		das Fehler Objekt - fehlt bei Erfolg

*/

var JSONFeed = function(){
	var getAsync = function(url, onRes, timeout){
		var acqJSONFeedRes = {
			url : url
		};	
		var acqJSONFeedOnSucc = function(data, textStatus, jqXHR){
			acqJSONFeedRes.succ = {
				data      :data      ,
				textStatus:textStatus,
				jqXHR     :jqXHR      
			};	
			onRes(acqJSONFeedRes);
		};
		var acqJSONFeedOnErr = function(jqXHR, textStatus, errorThrown){
			acqJSONFeedRes.err = {
				jqXHR      :jqXHR      ,
				textStatus :textStatus ,
				errorThrown:errorThrown      
			};
			onRes(acqJSONFeedRes);
		};
		$.ajax({
			url    : url             ,
			success:acqJSONFeedOnSucc,
			error  :acqJSONFeedOnErr ,
			data   : 'json'          ,
			type   : 'GET'           ,
			timeout: timeout 
		});
	}
	var JSONFeed_ = {
		getAsync: getAsync
	}
	return JSONFeed_;
}();	
