/*

Nuetzliche String-Funktionen - i.A. uebersetzt aus der Python-Lib "string". 

	- sub
		Substring a la Python. -1 bezeichnet das letzte Zeichen, -2 das vorletzte, usw.
	- multiSplit
		wie String.split, aber an einer Reihe vom SplitPatterns.
	- removeTags
		entfernt alle HTML-Tags und gibt PlainText zurueck
		
*/

var Maths; if(!Maths){alert('Maths is not defined (Maths.js has probably not been loaded).');}

var Strings = function(){

	var Strings_ = {};

	// Java-Methode String.hashCode() uebersetzt 
    var getHash = function(str){
        var hash =          0;
        var lngt = str.length;
        for (index = 0; index < lngt; ++index) {
            code   = str.charCodeAt(index);
            hash = ((hash << 5) - hash) + code;
            hash = hash & hash;
        }
        return hash;
    }
    
	var beginsWith = function(str, pat){return pat == sub(str,           0, pat.length);}
	var endsWith   = function(str, pat){return pat == sub(str, -pat.length,          0);}

	var sub = function(string, frPos, toPos){
		var stringLength = string.length;
		if(!frPos) frPos = 0; frPos = Maths.modulo(frPos    , stringLength)    ;
		if(!toPos) toPos = 0; toPos = Maths.modulo(toPos - 1, stringLength) + 1;
		var retval = string.substring(frPos, toPos);
		return retval;
	};
	
	var multiSplit = function(text, pats){
		var multiSplit_ = function(text, pats, indexOfPat){
			var texts = [];
			if(indexOfPat >= 0){
				var pat              = pats[--indexOfPat];
				var subTexts         = multiSplit_(text, pats, indexOfPat);
				var numberOfSubTexts = subTexts.length;
				for (var indexOfSubText = 0; indexOfSubText < numberOfSubTexts; ++indexOfSubText){
					var subText             = subTexts[indexOfSubText];
					var subSubTexts         = subText.split(pat);
					var numberOfSubSubTexts = subSubTexts.length;
					for (var indexOfSubSubText = 0; indexOfSubSubText < numberOfSubSubTexts; ++indexOfSubSubText){
						var subSubText = subSubTexts[indexOfSubSubText];
						texts.push(subSubText);
					}					
				}
			}
			else{
				texts.push(text);
			}
			return texts;
		}
		return multiSplit_(text, pats, pats.length);
	}
		
	var replace = function(text, oldPat, newPat){
		text = text.split(oldPat);
		text = text.join (newPat);
		return text;
	}
		
	var replaceTags = function(html, repl){
		var text = []   ;
		var inTag  = false;
		var numberOfChrs = html.length;
		for(var indexOfChr = 0; indexOfChr < numberOfChrs; ++indexOfChr){
			var chr   = html.charAt(indexOfChr);
			var isBra = chr == '<';
			var isCat = chr == '>';
			var isNrm = !isBra && !isCat;
			if(inTag){
				if(isCat){
					inTag = false;
					text.push(repl);
				}
			}
			else{
				if(isBra){inTag = true ;}
				if(isNrm){text.push(chr);}		
			} 
		}		
		
		text = text.join('');
		return text;
	}

	var removeTags = function(html){
		return replaceTags(html,'');
	}

	Strings_.sub        = sub       ;
	Strings_.multiSplit = multiSplit;
	
	Strings_.replaceTags = replaceTags;
	Strings_.removeTags  = removeTags ;
	
	Strings_.beginsWith = beginsWith;
	Strings_.endsWith   = endsWith  ;

	Strings_.replace = replace;
	Strings_.getHash = getHash;

	return Strings_;
}();