/*

Die Schnittstelle zur Schnittstelle, formerly known as TelekomPush

*/

var TKConnector;

try{
	TKConnector = function(){

		var cVersion = 50

		var setTags = function(aTags){
			UAirship.setTags(aTags, function(){
				MKLog.log('DID_SET_TAGS')
				MKLog.logJSON(aTags)
				MKLog.log('/DID_SET_TAGS')
			})
		}

		var onFin = function() {
			MKLog.log('onFin(' + cVersion + ')')
		}

		var setOnFin = function(aOnFin){
			onFin = aOnFin;
		}

		var onRdy = function() {
			MKLog.log('onRdy(' + cVersion + ')')
		}

		var setOnRdy = function(aOnRdy){
			onRdy = aOnRdy;
		}

		var onArticleID = function(articleID) {
			MKLog.log    ('onArticleID(' + cVersion + ')')
			MKLog.log(articleID)
		}

		var setOnArticleID = function(aOnArticleID){
			onArticleID = aOnArticleID;
		}

		var extractArticleID = function(aEvent){
			var             vArticleID
			try            {vArticleID = aEvent.extras.articleID}
			catch(aExc)    {vArticleID = ''                     }
			return vArticleID
		}

		var extractMessage = function(aEvent){
			var           vMessage
			try          {vMessage = aEvent.message}
			catch(aExc)  {vMessage = ''            }
			return vMessage
		}


		var onPsh = function(aEvent){
			MKLog.log('onPsh')

			try{
				var vArticleID = extractArticleID(aEvent)
				var vMessage   = extractMessage  (aEvent)

				var vLogJSON = {}
				vLogJSON.vrs=cVersion
				vLogJSON.art=vArticleID
				vLogJSON.msg=vMessage
			
				MKLog.logJSON(vLogJSON)
				
				onArticleID(vArticleID)
				
			}			
			catch(aExc){
				MKLog.log(aExc)
			}
			
			MKLog.log('/onPsh')
		}

		var innerOnRdy = function() {
			document.addEventListener("urbanairship.push", onPsh, false)
			document.addEventListener("resume", function() {
					UAirship.resetBadge()
					UAirship.getLaunchNotification(true, onPsh)

					document.addEventListener("urbanairship.push", onPsh, false)
			}, false)

			document.addEventListener("pause", function() {
					document.removeEventListener("urbanairship.push", onPsh, false)
			}, false)

			UAirship.getLaunchNotification(true, onPsh)

			UAirship.getChannelID(function(aChannelID) {
				if(aChannelID) {
					UAirship.setUserNotificationsEnabled(true, onFin)
					MKLog.log("CHANNELID '" + aChannelID + "'")
				}
			})
			onRdy();
		}


		document.addEventListener("deviceready", innerOnRdy, false)

		var TKConnectorObject = {}

		TKConnectorObject.setOnArticleID = setOnArticleID
		TKConnectorObject.setTags        = setTags
		TKConnectorObject.setOnRdy       = setOnRdy
		TKConnectorObject.setOnFin       = setOnFin

		return TKConnectorObject;	

	}();
	MKLog.log('TKConnectorObject::OK');

}
catch(aExc){
	MKLog.log('TKConnectorObject::EXC' + aExc);
}