/*

Klasse: TelekomActivityIndicator

Methoden:

	inc()
	dec()
	count()
	reset()

Zeigt den ActivityIndicator, wenn die Anzahl der Threads auf die gewartet wird,
positiv ist. 

Im ersten Moment wuerde man vielleicht Methoden wie show und hide erwarten - das ist
aber inadaequat, wenn mehrere Threads parallel ausgefuehrt werden.

Statt dessen ruft man beim Start des Threads TelekomActivityIndicator.inc()
und beim Verlassen des Threads TelekomActivityIndicator.dec() auf oder uebergibt
die Methoden als Callbacks.

Mit count laesst sich abfragen, auf wie viele Threads zur Zeit gewartet wird.

*/


var TelekomActivityIndicator = function(){
	var TelekomActivityIndicator_ = {};
	var numberOfActivities = 0;
	var mov = function(dst){
		var oldState = !!numberOfActivities;
		numberOfActivities += dst;
		if(numberOfActivities < 0){numberOfActivities = 0;}
		var newState = !!numberOfActivities;
		if(!oldState &&  newState){$.mobile.showPageLoadingMsg();}
		if( oldState && !newState){$.mobile.hidePageLoadingMsg();}
	}
	var getNumberOfActivities = function(){
		return numberOfActivities;
	}
	var inc = function(){mov( 1);}
	var dec = function(){mov(-1);}
	var res = function(){mov(-numberOfActivities);}
	TelekomActivityIndicator_.inc = inc;
	TelekomActivityIndicator_.dec = dec;
	TelekomActivityIndicator_.count = getNumberOfActivities;
	TelekomActivityIndicator_.reset = res                  ;
	return TelekomActivityIndicator_;	
	
}();
	
