/*

	Author: Horst
	Datum: 27.6.12
	
	Diese Klasse laedt, cacht und bereitet das komplette JSON von der Telekom auf. 
	Ueberraschenderweise laesst das Ladeverhalten das naemlich zu. Das OPML und alle 
	Channels werden dabei zu einem einzigen komplexen Objekt zusammengesetzt.
	
	Methoden:
	
		getAsync(force, callBack)
			ruft die Funktion callBack mir dem globalen JSON-Objekt als Argument auf.
			Bei force == true oder leerem cache wird das globalen JSON-Objekt neu 
			geladen / erzeugt. Default ist false.

	Beispielaufruf (im Kontext):
	
		var onJSON = function(json){
			// mach was mit dem JSON
		}
		TelekomGlobalJSONCache.getAsync(onJSON, true);
		
*/

var getShouldLog = function(){
	var vShouldLog
	
	vShouldLog = true
	vShouldLog = false
	
	return vShouldLog
}

var TelekomGlobalJSONCache = function(){

var getOutlineID = function(outline){
	return outline.uuid;
}
var getArticleID = function(article){
	var articleID = article['im:widget_id'].id;

	//MKLog.log('articleID: ' + articleID)
	
	//	var articleID = Count.count();
	//	alert('articleID: ' + articleID);
	
	return articleID;
}

	// Const
	var OPML_URL_EN = 'http://gorss3.infomantis.de/social/index.php?app=gorss-telekom-socialmedia&opml=42'; // der URL des englischen initialen Feeds
	var OPML_URL_DE = 'http://gorss3.infomantis.de/social/index.php?app=gorss-telekom-socialmedia&opml=38'; // der URL des deutschen  initialen Feeds
	var MAX_NUMBER_OF_ARTICLES           =   3; // die max Anzahl der Artikel pro Kanal
	var MAX_ARTICLE_DESCRIPTION_LENGTH   = 100; // danach wird der Artikeltext in der Liste abgeschnitten
	var MAX_ARTICLE_OUTLINE_TITLE_LENGTH =  15; // danach wird der Outline-Titel im Artikelheader abgeschnitten
	
	// Vegleichsfunktion fuer Outlines
	var outlineCompar = function(outline0, outline1){
		var seqIndex0    = outline0['seq-index'];
		var seqIndex1    = outline1['seq-index'];
		var seqIndexInt0 = parseInt(seqIndex0);
		var seqIndexInt1 = parseInt(seqIndex1);
		var compar       = seqIndexInt0 - seqIndexInt1;
		return compar;
	}
	// /Const
	var cachedResult; // das gecachte JSON, Closure
	var async = function(){ // Die Funtkion, die die Ladefunktion erzeugt (Kniff, Closure)
		var _async = function(onAllJSON, force){ // Die Ladefunktion
		
		//	alert('settings: ' + MKJSON.toString(settings));
			
			// Wenn was schiefgeht
			var onExc = function(exc){
				cLog('onExc');
				cLog(exc);
				cLog(exc.stack);
				TelekomActivityIndicator.reset();
				showErrorPage();
				cLog('/onExc');
			}

			 // Mach HTML zu Text, Helper
			var removeTagsAndTruncate = function(html, shouldTruncateAtBr){
				if(shouldTruncateAtBr){
					var lowerCaseHTML = html.toLowerCase();
					var indexOfBR     = lowerCaseHTML.indexOf('<br');
					if(indexOfBR >= 0){
						html = html.substring(0, indexOfBR);
					}	
				}
				var text = []   ;
				var inTag  = false;
				$.each(html, function(indexOfChr, chr){
				   var isBra = chr == '<';
				   var isCat = chr == '>';
				   var isNrm = !isBra && !isCat;
				   if(inTag){
						if(isCat){
							inTag = false;
							text.push(' ');
						}
				   }else{
					   if(isBra){inTag = true;  }
					   if(isNrm){text.push(chr);}		
				   } 
			   });
				text = text.join('');
				return text;
			}

			var onOPMLJSON = function(opmlJSON){// Callback des initialen Feeds (OPML)
				try{
					var vIURL = opmlJSON.succ.data.body.imprint.url

					var onImprintJSON = function(imprJSON){
						onOPMLImprintJSON(opmlJSON, imprJSON)
					}
					 
					TelekomJSONFeed.getOneAsync(vIURL, onImprintJSON);

				}catch(exc){
					onExc(exc);
				}

			}
			
			var onOPMLImprintJSON = function(opmlJSON, imprJSON){// Callback des erweiterten initialen Feeds (OPML)

				var vImpr      = {}
				var vImprTitle = ''
				var vImprDescr = ''
				try{
					var vImprRaw = imprJSON.succ.data.channel.items[0]
					vImprTitle   = vImprRaw.title
					vImprDescr   = vImprRaw.description
				}catch(exc){onExc(exc);}
				vImpr['title'] = vImprTitle
				vImpr['descr'] = vImprDescr

				// bereitet das JSON des initialen Feeds auf
				try{
					var body             = opmlJSON.succ.data.body;
					var outlines         = body.outlines          ;
					var outlineURLsObj   = {}; // enthaelt die URLIndices
					var outlineURLsArr   = []; // enthaelt die URLs
					var lastOutlineIndex = outlines.length -1;
					outlines.sort(outlineCompar);
												
					body.impr = vImpr

					$.each(outlines, function(indexOfOutline, outline){
						var outlineFirst                    = indexOfOutline ==                0;
						var outlineLast                     = indexOfOutline == lastOutlineIndex;
						var outlineURL                      = outline.url;
						outline.index                       = indexOfOutline;
						outline.collapsibleID               = Count.count();
						outline.shouldReceivePushCheckBoxID = Count.count();
						outline.shouldBeDisplayedCheckBoxID = Count.count();
						outline.isCollapsibleOpen           = outlineFirst;
						outline.id                          = getOutlineID(outline);
						outline.isLast                      = outlineLast;
						if(cachedResult){
							$.each(cachedResult, function(indexOfCachedOutline, cachedOutline){
								if(outline.url == cachedOutline.url){
									outline.isCollapsibleOpen = cachedOutline.isCollapsibleOpen;
								}	
							});
						}
						if(!outlineURLsObj[outlineURL]){
							outlineURLsObj[outlineURL] = [outlineURLsArr.length];
							outlineURLsArr.push(outlineURL);
						}
					});

					var onSettings = function(settings){
					
						var vShouldLog = getShouldLog();
					
						body.settings = settings;
						var onChannelJSONs = function(channelJSONs){// Callback der Channel-Feeds
							// bereitet das JSON der Channel-Feeds
							// und baut sie in das JSON des initialen Feeds ein
							try{
								$.each(outlines, function(indexOfOutline, outline){
										
									// welche Channels gibt es
									// keine Doppel
									// und wohin gehoeren sie im initialen JSON
									var indexOfChannel   = outlineURLsObj[outline.url][0];
									var channelJSON      = channelJSONs[indexOfChannel];
									var channel          = channelJSON.succ.data.channel;
									var channelItems     = channel.items;
									var articles         = [];

									if(!channelItems){channelItems = [];}
									// Welche Artikel gibt es
									// die ersten n Channel-Items
									// und Aufbereitung der Artikel
									$.each(channelItems, function(indexOfArticle, article){

										// wenn man das JSON ansehen will
										// muss man es auf ertraegliche Laenge reduzieren
										//article.description = 'ARTICLE_DESCRIPTION';
										
										if(vShouldLog){
											article.description = 'ARTICLE_DESCRIPTION';
										}
	
										if(indexOfArticle < MAX_NUMBER_OF_ARTICLES){
											article.index        = indexOfArticle;
											article.outlineID    = outline.id   ; // wohin gehoert er im initialen JSON
											article.outlineIndex = outline.index; // wohin gehoert er im initialen JSON
											article.outlineTitle = outline.title;
											article.id           = getArticleID(article);
											article.liID         = Count.count();
											article.topmostID    = Count.count();
	
											var articleEnclosures = article.enclosures;
											var articleEnclosure2 = {};
											if(articleEnclosures){
												$.each(articleEnclosures, function(indexOfArticleEnclosure, articleEnclosure){
													var articleEnclosure2Map    = {};
													var articleEnclosure2ID     = Count.count();
													var articleEnclosure2URL    = articleEnclosure.url;
													var articleEnclosure2ImSize = articleEnclosure["im:size"];
													articleEnclosure2Map.id  = articleEnclosure2ID ;
													articleEnclosure2Map.url = articleEnclosure2URL;
													articleEnclosure2[articleEnclosure2ImSize] = articleEnclosure2Map;
												});
											}
											article.enclosure2 = articleEnclosure2;
											article.parsedDescription  = removeTagsAndTruncate(article.description , true ).substr(0, MAX_ARTICLE_DESCRIPTION_LENGTH  ) + ' ...';
											article.parsedOutlineTitle = removeTagsAndTruncate(article.outlineTitle, false).substr(0, MAX_ARTICLE_OUTLINE_TITLE_LENGTH) + ' ...';
											articles.push(article);
										}
										
									});
									// Das initiale JSON kennt jetzt diesen Channel
									outline.channel  = channel ;	
		
									// Der Channel kennt jetzt seine Artikel
									channel.articles = articles;		
									
									// Der Channel braucht jetzt keine Items mehr
									//channel.items = undefined;	

								});// each outlines
								// Das initiale JSON kennt jetzt seine Channels
							}catch(exc){onExc(exc);}
							cachedResult  = body;	
							var allJSON = {
								json:cachedResult,
								cached:false
							};	
							
							// Wenn man das JSON ansehen moechte
							// Kopieren aus dem Alert geht.
							//alert(MKJSON.toString(allJSON));
							
							if(vShouldLog){
								MKLog.logJSON(allJSON)
							}
													
							onAllJSON(allJSON);
						} // onChannelJSONs
						TelekomJSONFeed.getManyAsync(outlineURLsArr, onChannelJSONs); 
					}
					onSettings(TelekomSettings.update(outlines));
				}catch(exc){onExc(exc);}
			} // onOPMLJSON

			if(force || !cachedResult){
				// lade und erzeuge neu
				var opmlURL;
				var vLocale = TelekomLocale.getLocale()
				if(vLocale == 'DE'){opmlURL = OPML_URL_DE;}
				if(vLocale == 'EN'){opmlURL = OPML_URL_EN;}
				TelekomJSONFeed.getOneAsync(opmlURL, onOPMLJSON);
			}else{			
				// antworte aus dem Cache
				var allJSON = {
					json:cachedResult,
					cached:true
				};	
				onAllJSON(allJSON);
			}
		}
		return _async;
	}();
	var TelekomGlobalJSONCache_ = {
		getAsync:async       
	}	
	return TelekomGlobalJSONCache_;
}();
