var VideoTagParser = function(){
	var VideoTagParser_ = {};

	var extractVideoTags = function(html){
		var videoTags = [];
		try{
			var videoSplitHTML = html.split('<video');
			$.each(videoSplitHTML, function(indexOfVideoSplit, videoSplit){
				if(indexOfVideoSplit){
					videoSplit = videoSplit.split('</video>')[0];
					videoSplit = '<video' + videoSplit + '</video>';
					videoTags.push(videoSplit);
				}
			});
		}catch(exc){}		
		return videoTags;
	}

	var digestVideoTag = function(videoTag){
		var digest;
		try{
			var digest_ = {};
			var posterSplit = videoTag   .split('poster="')[1];
			var poster      = posterSplit.split('"'       )[0];
			var sourceSplit = videoTag   .split('src="'   )[1];
			var source      = sourceSplit.split('"'       )[0];
			digest_.poster = poster;	
			digest_.source = source;	
			digest = digest_;
		}catch(exc){}
		return digest;
	}

	var makeImageTag = function(digest){
		var imageTag;
		if(digest){
			try{
				var imageTag_ = [];
				imageTag_.push('<a target="_blank" href="');
				imageTag_.push(digest.source              );
				imageTag_.push('"><img src="'             );
				imageTag_.push(digest.poster              );
				imageTag_.push('"></a>'                   );
				imageTag_ = imageTag_.join('');
				imageTag = imageTag_;
			}catch(exc){}
		}		
		return imageTag;
	}
	
	var parse = function(html){
		var videoTags = extractVideoTags(html);
		$.each(videoTags, function(indexOfVideoTag, videoTag){
			var digest   = digestVideoTag(videoTag);
			var imageTag = makeImageTag  (digest  );
			if(imageTag){
				html = Strings.replace(html, videoTag, imageTag);
			}
		});
		return html;
	}

	VideoTagParser_.parse = parse;
	
	return VideoTagParser_;
	
}();