/*

Ein Wrapper um die SHA Funktionen zum Zugriff auf den Telekom Proxy.

Methoden: 

	- getStrTime(time) 
		gibt den numerischen timeStamp (optional) als String zurueck. Default ist der 
		aktuelle Time Stamp.

	- getToken(url, timeStamp)
		gibt den Auth-Token fuer einen URL (obligatorisch) und einen timeStamp (optional)
		zurueck. Default ist der aktuelle timeStamp.

	- getParamString(url, timeStamp)
		gibt den Parameter-String fuer einen URL (obligatorisch) und einen timeStamp 
		(optional) zurueck. Default ist der aktuelle timeStamp.
		
	- getURLString(url, timeStamp)
		gibt den Proxy-URL-String fuer eine JSON-Resource fuer einen URL (obligatorisch) und einen timeStamp 
		(optional) zurueck. Default ist der aktuelle timeStamp.
		
	- getImgURLString(url, timeStamp)
		gibt den Proxy-URL-String fuer eine HTML-Resource fuer einen URL (obligatorisch) und einen timeStamp 
		(optional) zurueck. Default ist der aktuelle timeStamp.
		
	- getHTMLURLString(url, timeStamp)
		gibt den Proxy-URL-String fuer eine HTML-Resource fuer einen URL (obligatorisch) und einen timeStamp 
		(optional) zurueck. Default ist der aktuelle timeStamp.

*/


var TimeStamp; if(!TimeStamp){alert('TimeStamp is not defined (TimeStamp.js has probably not been loaded).');}

var TelekomCrypto = function(){
	var secret = 'vk6PXsfqNNLgPACZsFm2vA47MgXQK5V354X7MnRUrX';
	var appID  = 'telekom-dev';  
	var domain = '';
	var getStrTime = function(time){
		return '' + parseInt((time == undefined) ? TimeStamp.timeStamp() : time)
	}
	var getToken = function(url, strTime){
		return (new jsSHA(url, 'ASCII')).getHMAC(secret + strTime, 'ASCII', 'SHA-1','HEX');
	}
	var getParamString = function(url, time){
		var encodedURL  = encodeURIComponent(url);
		var strTime     = getStrTime(time);
		var token       = getToken(url, strTime);		
		var paramString = '&url=' + encodedURL + '&time=' + strTime + '&token=' + token;
		return paramString;
	}
	var getURLString = function(url, time){
		var urlString = 'http://proxy.infomantis.de/?appid=telekom-dev&type=telekom-jsonfeed&' + getParamString(url, time);
		return urlString;
	}
	var getImgURLString = function(url, time){
		var urlString = 'http://proxy.infomantis.de/?appid=telekom-dev&type=img&' + getParamString(url, time);
		return urlString;
	}
	var getHTMLURLString = function(url, time){
		var urlString = 'http://proxy.infomantis.de/?appid=telekom-dev&type=stuff&' + getParamString(url, time);
		return urlString;
	}
	var TelekomCrypto_ = {
		getHTMLURLString: getHTMLURLString,
		getImgURLString : getImgURLString,
		getParamString  : getParamString ,
		getURLString    : getURLString   
	};
	return TelekomCrypto_;
}();
